# 2 x 2
# configuration:
#   a  c
#   b  d

## - changing observed, expected fixed  Figure 1 & 3

# Figure 1 full x axis
#
# set expected cell values
E <- vector(length=4)
for (i in 1:4) {
  E[i] <- 50
}
df = 1; Lo = 1; Hi = 99
layout(matrix(1))

# 2*(E[1]*log(E[1]/x)+E[2]*log(E[2]/(100-x))+E[3]*log(E[3]/(100-x))+(E[4]*log(E[4]/x))) # observed switched with expected

curve(2*(x*log(x/E[1])+(100-x)*log((100-x)/E[2])+(100-x)*log((100-x)/E[3])+(x*log(x/E[4]))), 
      xlim = c(Lo,Hi), ylab = "Statistic",
      xlab = "Observed value", cex.lab = 1.4, lwd = 2)              #LRT

##check specific values
x=20
2*(x*log(x/E[1])+(100-x)*log((100-x)/E[2])+(100-x)*log((100-x)/E[3])+(x*log(x/E[4])))

curve((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
        ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4],
      add = TRUE, lty = 2, col = "blue", lwd = 2)         #chi-sq 

#check value
(x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4]


curve(2*(df*0.5*log(df/((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
                          ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4]))
         -0.5*(df-((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
                     ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4]))), 
      add = TRUE, lty = 3, col = "red", lwd = 1)         #2*Svar
legend(60,230, inset=0.2, legend=c("LRT", expression(X^2), expression('2S'[var])),
       col=c("black", "blue", "red"), lty=1:3, lwd = 2, cex=1, title = "Equation used")

#check value
2*(df*0.5*log(df/((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
                    ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4]))
   -0.5*(df-((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
               ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4])))
# abline(v=20)


# Figure 2 expanded x axis
#
# set expected cell values
E <- vector(length=4)
for (i in 1:4) {
  E[i] <- 50
}
df = 1; Lo = 40; Hi = 60
layout(matrix(1))

curve(2*(x*log(x/E[1])+(100-x)*log((100-x)/E[2])+(100-x)*log((100-x)/E[3])+(x*log(x/E[4]))), 
      xlim = c(Lo,Hi), ylab = "Statistic",
      xlab = "Observed value", cex.lab = 1.4, lwd = 2)              #LRT

##check specific values
x=45
2*(x*log(x/E[1])+(100-x)*log((100-x)/E[2])+(100-x)*log((100-x)/E[3])+(x*log(x/E[4])))

curve((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
        ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4],
      add = TRUE, lty = 2, col = "blue", lwd = 2)         #chi-sq 

(x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4]


curve(2*(df*0.5*log(df/((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
                          ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4]))
         -0.5*(df-((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
                 ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4]))), 
      add = TRUE, lty = 3, col = "red", lwd = 1)         #2*Svar

2*(df*0.5*log(df/((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
                    ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4]))
   -0.5*(df-((x-E[1])^2/E[1]+((100-x)-E[2])^2/E[2]+
               ((100-x)-E[3])^2/E[3]+(x-E[4])^2/E[4])))
legend(52,7.5, inset=0.2, legend=c("LRT", expression(X^2), expression('2S'[var])),
       col=c("black", "blue", "red"), lty=1:3, lwd = 2, cex=1, title = "Equation used")
#abline(v=20)


## - MATRIX - changing observed, expected fixed - Figure 3
#
layout(matrix(1))
layout(matrix(1:4, nrow = 2))
O1 = 50; O2 = 50; O3 = 50; O4 = 50; T = O1 + O2 + O3 + O4; df = 1
CT1 = O1 + O2; CT2 = O3 + O4; RT1 = O1 + O3; RT2 = O2 + O4

#Ep = 0.2
E1 = 20; E2 = (CT1-E1); E3 = (RT1-E1); E4 = (RT2-E2)
Lo = 1; Hi = 60
x=1

curve(2*(x*log(x/E1)+(CT1-x)*log((CT1-x)/E2)+(RT1-x)*
           log((RT1-x)/E3)+(RT2+(x)-CT1)*log((RT2+(x)-CT1)/E4)), 
      xlim = c(Lo,Hi), ylim = c(0,155), ylab = "Statistic",
      xlab = "", cex.lab = 1.4, lwd = 2)              #LRT

curve((x-E1)^2/E1+((CT1-x)-E2)^2/E2+
        ((RT1-x)-E3)^2/E3+((RT2+x-CT1)-E4)^2/E4,
      add = TRUE, lty = 2, col = "blue", lwd = 2)         #chi-sq 
legend(20,150, legend=substitute(italic("E = 20   ")), box.lty=0)

Ep = 50
E1 = 50; E2 = CT1-E1; E3 = RT1-E1; E4 = RT1-E2
Lo = 10; Hi = 90
curve(2*(x*log(x/E1)+(CT1-x)*log((CT1-x)/E2)+(RT1-x)*
           log((RT1-x)/E3)+(RT2+(x)-CT1)*log((RT2+(x)-CT1)/E4)), 
      xlim = c(Lo,Hi), ylab = "Statistic",
      xlab = "Observed Value", cex.lab = 1.4, lwd = 2)              #LRT
curve((x-E1)^2/E1+((CT1-x)-E2)^2/E2+
        ((RT1-x)-E3)^2/E3+((RT2+(x)-CT1)-E4)^2/E4,
      add = TRUE, lty = 2, col = "blue", lwd = 2)         #chi-sq 
legend(40,145, legend=substitute(italic("E = 50   ")), box.lty=0)

Ep = 30
E1 = 30; E2 = CT1-E1; E3 = RT1-E1; E4 = RT1-E2
Lo = 1; Hi = 70
curve(2*(x*log(x/E1)+(CT1-x)*log((CT1-x)/E2)+(RT1-x)*
           log((RT1-x)/E3)+(RT2+(x)-CT1)*log((RT2+(x)-CT1)/E4)), 
      xlim = c(Lo,Hi), ylab = "",
      xlab = "", cex.lab = 1.4, lwd = 2)              #LRT
curve((x-E1)^2/E1+((CT1-x)-E2)^2/E2+
        ((RT1-x)-E3)^2/E3+((RT2+(x)-CT1)-E4)^2/E4,
      add = TRUE, lty = 2, col = "blue", lwd = 2)         #chi-sq 
legend(25,132, legend=substitute(italic("E = 30   ")), box.lty=0)

Ep = 90
E1 = 90; E2 = CT1-E1; E3 = RT1-E1; E4 = RT1-E2
Lo = 61; Hi = 99
curve(2*(x*log(x/E1)+(CT1-x)*log((CT1-x)/E2)+(RT1-x)*
           log((RT1-x)/E3)+(RT2+(x)-CT1)*log((RT2+(x)-CT1)/E4)), 
      xlim = c(Lo,Hi), ylim = c(0,125), ylab = "",
      xlab = "Observed Value", cex.lab = 1.4, lwd = 2)              #LRT
curve((x-E1)^2/E1+((CT1-x)-E2)^2/E2+
        ((RT1-x)-E3)^2/E3+((RT2+(x)-CT1)-E4)^2/E4,
      add = TRUE, lty = 2, col = "blue", lwd = 2)         #chi-sq 
legend(70,122, legend=substitute(italic("E = 90   ")), box.lty=0)

legend(85,125, inset=0.02, legend=c("LRT", expression(X^2)),
       col=c("black", "blue"), lty=1:2, lwd = 2, cex=1, title = "Equation used")

layout(matrix(1))

# Figure 4
# simulation for 2 x 2, rows fixed X2 and LRT, % of Type I & II errors

library(MonteCarlo)
library(writexl)

# Define function that generates data and applies the method of interest

chis <- function(n,probA, probB, probA2){
  
  # generate sample:
  
  scorA <- rbinom(1,n,probA)
  scorA2 <- rbinom(1,n,probA2)
  scorB <- rbinom(1,n,probB)
  scorC <- n - scorA
  scorC2 <- n - scorA2
  scorD <- n - scorB
  
  tab <- as.table(rbind(c(scorA,scorC),c(scorB,scorD)))
  tab2 <- as.table(rbind(c(scorA2,scorC2),c(scorB,scorD)))
  
  # calculate statistics:
  
  mod <- suppressWarnings(chisq.test(tab,correct = FALSE))
  mod2 <- suppressWarnings(chisq.test(tab2,correct = FALSE))
  dof <- unname(mod$parameter)
  dof2 <- unname(mod2$parameter)
  
  # for type I errors
  X2 <- mod$statistic
  if (scorA == 0 && scorB == 0) {
    LRT <- 0
    X2 <- 0
    pX2 <- 1
  } else {
    tabt1 <- mod$observed
    for (i in 1:length(tab)) {
      tabt1[i] <- mod$observed[i]
      if (mod$observed[i] < 1) tabt1[i]=1   # turn 0s into 1s for one table used for log
      pX2 <- unname(mod$p.value)
      LRT <- 2*sum(mod$observed * log(tabt1/mod$expected))
    }
  }
  
  # for type II errors
  
  X22 <- mod2$statistic
  if (scorA2 == 0 && scorB == 0) {
    LRT2 <- 0
    X22 <- 0
    pX22 <- 1
  } else {
    tabt1 <- mod2$observed
    for (i in 1:length(tab2)) {
      tabt1[i] <- mod2$observed[i]
      if (mod2$observed[i] < 1) tabt1[i]=1   # turn 0s into 1s for one table used for log
      pX22 <- unname(mod2$p.value)
      LRT2 <- 2*sum(mod2$observed * log(tabt1/mod2$expected))
    }
  }
  
  
  return(list("A"= scorA, "A2"= scorA2, "B"=scorB, "C"=scorC, "C2"=scorC2, "D"=scorD, 
              "X2"=unname(X2), "LRT"=unname(LRT), "pX2"= pX2, "pLRT"= unname(1-pchisq(LRT, dof)),
              "X22"=unname(X22), "LRT2"=unname(LRT2), "pX22"= pX22, "pLRT2"= unname(1-pchisq(LRT2, dof2))))
  
}

set.seed(9)

# define parameter grid:

j=0
pB=0; pcX2=0; pcLRT=0; pcX22=0; pcLRT2=0
for(i in seq(from=0.005, to=.095, by=0.005)) {  # change to=.5 for full data
  npX2=0; npLRT=0; npX22=0; npLRT2=0
  probA <- i
  probA2 <- 0.1
  probB <- i
  n <- 100
  sig <- 0.05
  nrep <- 50000
  
  param_list=list("n" = n, "probA" = probA, "probA2" = probA2, "probB" = probB)
  MC_result <- MonteCarlo(func=chis, nrep=nrep, param_list=param_list)
  df <- suppressWarnings(MakeFrame(MC_result))
  #  head(df)
  #  file_title <- paste0("PA",probA, "PB",probB, "sig",sig,".xlsx")
  #  write_xlsx(df, file_title)        # produce file with all output
  
  for(k in 1:nrep) {
    if(df$pX2[k] <= sig) npX2 <- npX2 + 1
    if(df$pLRT[k] <= sig) npLRT <- npLRT + 1
    if(df$pX22[k] > sig) npX22 <- npX22 + 1
    if(df$pLRT2[k] > sig) npLRT2 <- npLRT2 + 1
    
  }
  j <- j + 1
  pB[j] <- i
  pcX2[j] <- 100*npX2/nrep
  pcLRT[j] <- 100*npLRT/nrep
  pcX22[j] <- 100*npX22/nrep
  pcLRT2[j] <- 100*npLRT2/nrep
  
}

len <- 19
x <- pB[1:len]
y1 <- pcLRT[1:len] - pcX2[1:len]
y2 <- pcLRT2[1:len] - pcX22[1:len]

legend_texts = c("Type I", "Type II")

# plot of difference in %s
smoothingSpline = smooth.spline(x, y1, spar=0.1)
plot(x,y1, xlab = "Binomial probability for 2nd row first cell", 
     ylab = "Difference in % errors", pch=16, ylim = c(-6,6))
lines(smoothingSpline, col='black', lty=2, lwd=1)
par(new=TRUE)
smoothingSpline = smooth.spline(x, y2, spar=0.1)
plot(x,y2, xlab = "Binomial probability for 2nd row first cell", 
     ylab = "Difference in % errors", pch=1, ylim = c(-6,6))
lines(smoothingSpline, col='red', lwd=1)
legend(0.073,6, inset=0.02, legend=legend_texts,
       pch=c(16,1), col=c('black','red'), lty=c(2,1), cex=1, title = "Error")
